function Labels = FSFclustering(X,K,DistStruct,Centers,PeakOpts,G_iterated)
% Compute a clustering as described in the original fast-search-and-find
% of density peaks paper (Nature 2014).  Use cover trees to get complexity 
% ~O(nlog(n)), versus O(n^2) as in their original paper.  

Labels=zeros(1,size(X,1));

Density=DistStruct.Density;

for k=1:K
    Labels(Centers(:,k))=k;
end

[~,idx]=sort(Density,'descend');

G=DistStruct.G;

for j=1:length(Labels)
    if Labels(idx(j))==0
        NN=FindNearestLabeledNeighbor(X,j,idx,G,G_iterated,PeakOpts);
        Labels(idx(j))=Labels(NN);
    end
    
end

end

