% Computes the local densitys of the points in an N x D matrix X, using the
% threshold value th.  Use K nearest neighbor.  A matrix of distances may
% be passed in.  

function Density = LocalDensity(X,G,PeakOpts)

Density=zeros(size(X,1),1);

if strcmp(PeakOpts.Data,'IP')
    sigma=0.0026;
elseif strcmp(PeakOpts.Data, 'Pavia')
    sigma=0.0028;
elseif strcmp(PeakOpts.Data,'SalinasA')
    sigma=0.0026;
end


for l=1:size(X,1)
    Density(l)=sum(exp(-(G.DistInfo.dists{l}(1:20).^2./sigma^2)));
end

end