%% Compute OA, AA, kappa for all methods.

%Performance quantitative analysis only on labeled pixels.
Yuse=UniqueGT(Y(Y>0));

if ~isempty(Y)
    %Raw kmeans
    
    [OAraw,AAraw,KappaRaw]=GetAccuracies(LabelsRaw(Y>0),Yuse,K_Learned);
    
    %Kmeans on PC projections
    [OApca,AApca,KappaPCA]=GetAccuracies(LabelsPCA(Y>0),Yuse,K_Learned);
    
    %Kmeans after random projections
    [OArandProj,AArandProj,KappaRandProj]=GetAccuracies(LabelsRandProj(Y>0),Yuse,K_Learned);
    
    %kmeans on independent componenents
    [OAica,AAica,KappaICA]=GetAccuracies(LabelsICA(Y>0),Yuse,K_Learned);
    
    %Spectral clustering
    [OAspectral,AAspectral,KappaSpectral]=GetAccuracies(LabelsSpectral(Y>0),Yuse,K_Learned);
    
    %GMM
    [OAgMM,AAgMM,KappaGMM]=GetAccuracies(LabelsGMM(Y>0),Yuse,K_Learned);
 
    %SMCE
    [OA_SMCE,AA_SMCE,KappaSMCE]=GetAccuracies(LabelsSMCE(Y>0),Yuse,K_Learned);
    
    %Hierarchical NMF
    [OA_NMF,AA_NMF,KappaNMF]=GetAccuracies(LabelsNMF(Y>0)',Yuse,K_Learned);
    
    %FSFDPC
    [OAfSFDPC,AAfSFDPC,KappafSFDPC]=GetAccuracies(LabelsFSFDPC(Y>0),Yuse,K_Learned);
    
    %Diffusion Learning
    [OA_DL,AA_DL,Kappa_DL]=GetAccuracies(Labels_DL(Y>0),Yuse,K_Learned);
    
    %Diffusion learning spatial-spectral
    [OA_DLSS,AA_DLSS,Kappa_DLSS]=GetAccuracies(Labels_DLSS(Y>0),Yuse,K_Learned);
    
    % Diffusion learning spatial-spectral with active learning
    [OA_DLSSActive,AA_DLSSActive,Kappa_DLSSActive]=GetAccuracies(Labels_DLSSActive(Y>0),Yuse,K_Learned);
      
end