% This toolbox implements the diffusion learning and spatial spectral
% learning algorithms as developed by James M. Murphy and Mauro Maggioni of
% Johns Hopkins University.  The toolbox also generates all figures and
% experiments shown in their papers on the topic.  Those who with to use
% this code should cite:
%
% Murphy, J. and M. Maggioni.  "Nonlinear Unsupervised Clustering of Hyperspectral
% Images with Applications to Anomaly Detection and Active Learning."
% 2017.
%
% In order to run the main learning algorithms one auxilliary directory is 
% required:
%
% DiffusionGeometry: http://www.math.jhu.edu/~mauro/#tab_DiffusionGeom
%
% To perform the comparisons appearing in the above paper, the following
% auxilliary directories are required:
%
% Sparse Manifold Clustering and Embedding (SMCE): http://www.vision.jhu.edu/code/
% Heirarchical Non-Negative Matrix Factorization (HNMF): https://sites.google.com/site/nicolasgillis/code
% Fast Independent Component Analysis (ICA): https://www.cs.helsinki.fi/u/ahyvarin/papers/fastica.shtml
% Fast Mumford-Shah (FMS): http://www.ipol.im/pub/art/2017/204/?utm_source=doi
%
% The main script is DiffusionLearningDemo.  Note that FMS must be
% compiled, and is not run in this simple script.  
% 
%
% (c) Copyright Johns Hopkins University, 2017, James M. Murphy
